//import KeyUpEvent = JQuery.KeyUpEvent;
//import KeyUpEvent = JQuery.KeyUpEvent;
var systemState = new SystemState();
function setup() {
    $('#tblMPS thead').append("<tr id='trMPS_head'><th>AD</th><th>Befehl</th></tr>");
    var mpsHead = $('#trMPS_head');
    for (var i = 0; i < 16; i++) {
        mpsHead.append($("<th>", { text: decimalToHex(i, 1) }));
    }
    mpsHead.append("<th>FA</th>");
    var mpsBody = $('#tblMPS tbody');
    var _loop_1 = function (i) {
        var hexLine = decimalToHex(i);
        mpsBody.append($("<tr>", { id: "trMPS_" + hexLine }));
        var mpsLine = $('#trMPS_' + hexLine);
        var tdComment = $("<td>", { id: "mpsComment_" + hexLine }).css({
            "white-space": "nowrap", "text-overflow": "ellipsis", "overflow": "hidden", "max-width": "1px"
        });
        var tdRowHead = $("<td>", { text: hexLine }).css("cursor", "default");
        tdRowHead.on("click", function () {
            if (!systemState.isManualMode() && $('#divBtnPause img').hasClass("btnDisabled"))
                systemState.currentMPS.set(i);
        });
        mpsLine.append(tdRowHead).append(tdComment);
        makeTDEditable(tdComment, function (text) {
            systemState.getMPS().lines[i].comment = text.substring(0, 25);
            if (text.length > 25)
                $(tdComment).html(text.substring(0, 25));
            updateAssembler();
            saveToSystemStorage();
        });
        var _loop_4 = function (j) {
            var hexCol = decimalToHex(j, 1);
            var newTD = $("<td>", { id: "mpsGate_" + hexLine + "_" + hexCol });
            mpsLine.append(newTD);
            newTD.on("click", function () {
                try {
                    if ($('#divBtnPause img').hasClass("btnDisabled")) {
                        systemState.setManualMode(false);
                        if ($("input[name=steuerung]:checked").val() != 'a') {
                            $('input[name=steuerung][value=a]').prop('checked', "checked");
                            onSteuerungChanged();
                        }
                        systemState.getMPS().lines[i].toggleGate(j);
                        if ($(this).text() == "")
                            $(this).text(hexCol);
                        else
                            $(this).text("");
                    }
                }
                catch (e) {
                    showToast(e.message);
                }
            }).css("cursor", "default");
        };
        for (var j = 0; j < 16; j++) {
            _loop_4(j);
        }
        var tdFA = $("<td>", { id: "mpsFA_" + hexLine, text: decimalToHex((i + 1) % 256), maxlength: 2 });
        mpsLine.append(tdFA);
        makeTDEditable(tdFA, function (text) {
            var fa = parseInt(text, 16);
            systemState.getMPS().lines[i].fa = fa;
            tdFA.html(decimalToHex(fa));
            saveToSystemStorage();
        }, validateNumber);
        bindContextMenu("#trMPS_" + hexLine, "#menuMPSRow", function () { return $('#txtMPSRow').val(i); });
    };
    for (var i = 0; i < 256; i++) {
        _loop_1(i);
    }
    // Kopfzeile
    var tblRAM = $('#tblRAM tbody');
    var firstLine = $("<tr>");
    firstLine.appendTo(tblRAM);
    firstLine.append($("<td>", { text: "RAD" }).css("font-weight", "bold"));
    for (var i = 0; i < 16; i++) {
        firstLine.append($("<td>", { text: decimalToHex(i) }).css({ "width": "24px", "text-align": "center", "font-weight": "bold" }));
    }
    for (var i = 0; i < 16; i++) {
        var theLine = $("<tr>");
        theLine.appendTo(tblRAM);
        theLine.append($("<td>", { text: decimalToHex(i * 16) }).css({ "font-weight": "bold", "text-align": "center" }));
        for (var j = 0; j < 16; j++) {
            var newTD = $("<td>", { id: "tdRAM_" + (16 * i + j), text: "00" });
            theLine.append(newTD);
        }
    }
    $('#tblAssembler thead').append("<tr id='trAssembler_head'><th>RAS</th><th>OP</th><th>nn</th><th>Befehl</th></tr>");
    var assemblerBody = $('#tblAssembler tbody');
    var _loop_2 = function (i) {
        $("<tr>", { id: "tr_assembler_" + i }).appendTo(assemblerBody)
            .append($("<td>", { text: decimalToHex(i) }))
            .append($("<td>", { id: "tdAssembler_" + i, text: "00" }))
            .append($("<td>", { id: "tdAssembler_" + (i + 1), text: "00" }))
            .append($("<td>", { id: "tdBefehl_" + i }));
        bindContextMenu("#tr_assembler_" + i, "#menuRAMRow", function () { return $('#txtAssemblerRow').val(i); });
        makeTDEditable($('#tdBefehl_' + i), function (text) {
            text = text.trim();
            var result = parseAssembler(text);
            if (result !== undefined) {
                systemState.ram[i].set(result[0]);
                systemState.ram[i + 1].set(result[1]);
            }
            else {
                if (text != "" && text.substring(0, 1) != ";" && systemState.comments[i] != text)
                    showToast("Ungültiger Befehl '" + text + "'");
                systemState.ram[i].set(0);
                systemState.ram[i + 1].set(0);
            }
            systemState.comments[i] = text;
            console.log(systemState.comments);
            updateAssembler();
        });
    };
    for (var i = 0; i < 256; i += 2) {
        _loop_2(i);
    }
    $('#txtOP, #txtIP, #txtAX, #txtBX, #txtSF, #txtSub, #txtALU, #txtConst1, #txtDR, #txtAR').attr({
        maxlength: 2,
        value: "00"
    }).css({ position: "absolute", left: 90, width: 30, "text-align": "right" })
        .each(function () {
        if ($(this).attr("data-label") != "") {
            $("<label>", {
                for: $(this).attr("id"),
                text: $(this).attr("data-label")
            })
                .css({
                position: "absolute",
                left: 90,
                width: 30,
                top: $(this).position().top - 20,
                "text-align": "right"
            }).appendTo($(this).parent());
        }
    });
    $('#txtSF').css({ width: 20, left: 95, "text-align": "center" }).val(0).attr("readonly", "readonly");
    $("label[for='txtSF']").css("top", 248 + 23);
    $('#txtSub').css({ width: 20, left: 155, "text-align": "center" }).val(1).attr("readonly", "readonly");
    $('#txtALU').css({ left: 312 }).val("00").attr("readonly", "readonly");
    $('#txtConst1').css({ width: 20, left: 300, "text-align": "center" }).val(1).attr("readonly", "readonly");
    $('#txtDR, #txtAR').css({ left: 76 });
    $("label[for='txtDR'], label[for='txtAR']").css("left", 76);
    var gates = [
        { icon: "rechts", value: 6, left: 58, top: 23, parent: '#divGates' },
        { icon: "rechts", value: 4, left: 58, top: 23 + 54, parent: '#divGates' },
        { icon: "rechts", value: 2, left: 58, top: 23 + 2 * 54, parent: '#divGates' },
        { icon: "rechts", value: 0, left: 58, top: 23 + 3 * 54, parent: '#divGates' },
        { icon: "rechts", value: 15, left: 145, top: 23, parent: '#divGates' },
        { icon: "rechts", value: 5, left: 145, top: 23 + 54, parent: '#divGates' },
        { icon: "rechts", value: 3, left: 145, top: 23 + 2 * 54, parent: '#divGates' },
        { icon: "rechts", value: 1, left: 145, top: 23 + 3 * 54, parent: '#divGates' },
        { icon: "links", value: 14, left: 58, top: 23 + 3 * 54 + 63, parent: '#divGates' },
        { icon: "rechts", value: 13, left: 205, top: 23 + 3 * 54 + 63, parent: '#divGates' },
        { icon: "rechts", value: 7, left: 340, top: 148, parent: '#divGates' },
        { icon: "links", value: 9, left: 15, top: 57, parent: "#divBus" },
        { icon: "rechts", value: 10, left: 15, top: 114, parent: "#divBus" },
        { icon: "rechts", value: 8, left: 15, top: 187, parent: "#divBus" },
        { icon: "rechts", value: 11, left: 145, top: 57, parent: "#divBus" },
        { icon: "links", value: 12, left: 145, top: 114, parent: "#divBus" }
    ];
    gates.forEach(function (g) {
        $(g.parent)
            .append($("<img>", {
            title: "Tor öffnen",
            alt: "Tor öffnen",
            src: "img/diode_rot_" + g.icon + ".svg",
            id: "imgGateO" + g.value
        })
            .css({
            position: "absolute",
            left: g.left,
            height: 18,
            "background-color": "#ddd",
            border: "solid 1px black",
            padding: "2px",
            top: g.top
        })
            .on("click", function () {
            toggleGate(g.value, true);
        }))
            .append($("<label>", { for: "imgGateO" + g.value, text: decimalToHex(g.value, 1) }).css({
            position: "absolute",
            left: g.left + 12,
            top: g.top - 19
        }))
            .append($("<img>", {
            title: "Tor schließen",
            alt: "Tor schließen",
            src: "img/diode_gruen_" + g.icon + ".svg",
            id: "imgGateC" + g.value
        })
            .css({
            position: "absolute",
            left: g.left,
            height: 18,
            "background-color": "#ddd",
            border: "solid 1px black",
            padding: "2px",
            display: "none",
            top: g.top
        })
            .on("click", function () {
            toggleGate(g.value, false);
        }));
    });
    $(window).on("resize", function () {
        doResize();
    });
    styleLoadButton("loadMPS", function (fileContent, fileName, isText) {
        var callback = function () {
            try {
                if (isText)
                    systemState.getMPS().loadMPD(fileContent);
                else
                    systemState.getMPS().loadMPS(new Uint8Array(fileContent));
                $('#txtMPSName').val(fileName.substring(0, fileName.lastIndexOf(".")));
                updateTitle();
                resetRegisters();
                displayMPSContent();
                updateAssembler();
            }
            catch (e) {
                showToast(e.message);
            }
        };
        if (systemState.getMPS().isChanged()) {
            prettyConfirm("Sind Sie sicher, dass Sie den MPS löschen wollen?", { breite: 400, hoehe: 200 }, callback);
        }
        else {
            callback();
        }
    }, function (fileName) { return endsWith(fileName, ".mpd"); });
    styleLoadButton("loadRAM", function (fileContent, fileName) {
        var callback = function () {
            try {
                if (endsWith(fileName, ".ras")) {
                    systemState.loadRAMRAS(fileContent);
                    $('input[name=ramanzeige][value=a]').prop('checked', "checked");
                }
                else if (endsWith(fileName, ".rad")) {
                    systemState.loadRAMRAD(fileContent);
                    $('input[name=ramanzeige][value=d]').prop('checked', "checked");
                }
                else if (endsWith(fileName, ".ram") || endsWith(fileName, ".erm")) {
                    systemState.loadRAMBinary(new Uint8Array(fileContent));
                }
                $('#txtRAMName').val(fileName.substring(0, fileName.lastIndexOf(".")));
                displayVariablen();
                updateTitle();
                onRAMDisplayChanged();
                resetRegisters();
                for (var i = 0; i < 256; i += 2) {
                    if (systemState.ram[i].get() == 0 && systemState.comments[i] != "")
                        $('#tdBefehl_' + i).html(systemState.comments[i]).addClass("assembler_comment");
                }
                updateAssembler();
            }
            catch (e) {
                showToast(e.message);
            }
        };
        if (systemState.isRAMChanged()) {
            prettyConfirm("Sind Sie sicher, dass Sie das RAM löschen wollen?", { breite: 400, hoehe: 200 }, callback);
        }
        else {
            callback();
        }
    }, function (fileName) { return endsWith(fileName, ".ras") || endsWith(fileName, ".rad"); });
    var divSld = $("#slider");
    divSld.slider({
        value: 11,
        min: 0,
        max: 16,
        step: 1,
        slide: function (event, ui) {
            onSliderChanged(ui.value);
        }
    });
    $('#slider span').attr("tabindex", divSld.attr("tabindex"));
    divSld.removeAttr("tabindex");
    [
        { id: "#txtAX", attribute: systemState.ax },
        { id: "#txtBX", attribute: systemState.bx },
        { id: "#txtIP", attribute: systemState.ip },
        { id: "#txtOP", attribute: systemState.op },
        { id: "#txtAR", attribute: systemState.ar },
        { id: "#txtDR", attribute: systemState.dr },
        { id: "#txtALU", attribute: systemState.alu },
    ].forEach(function (m) {
        // Update Modell -> GUI
        m.attribute.addObserver(function (o, n) {
            if (o != n)
                $(m.id).val(decimalToHex(n));
        });
        // Update GUI -> Modell
        $(m.id).on("change", function (e) {
            var val = $(e.target).val();
            var n = parseInt(val, 16);
            if (n >= 0 && n <= 255) {
                m.attribute.set(n);
            }
            else {
                $(e.target).val(decimalToHex(systemState.ax.get()));
                showToast("Ungültige Eingabe '" + val + "'");
            }
        });
    });
    var _loop_3 = function (i) {
        // Update Modell -> GUI
        systemState.ram[i].addObserver(function (o, n) {
            var newVal = decimalToHex(n);
            var td = $('#tdRAM_' + i);
            var oldVal = td.html();
            if (o != n || newVal != oldVal) {
                td.html(newVal);
            }
            td = $('#tdAssembler_' + i);
            oldVal = td.html();
            if (o != n || newVal != oldVal) {
                td.html(newVal);
            }
        });
        // Update GUI -> Modell
        makeTDEditable($('#tdRAM_' + i), function (text) {
            systemState.ram[i].set(parseInt(text, 16));
            updateAssembler();
        }, validateNumber, function () {
            var nextCell = (i + 1) % 256;
            $('#tdRAM_' + nextCell).trigger('click');
        });
        makeTDEditable($("#tdAssembler_" + i), function (text) {
            var newVal = parseInt(text, 16);
            var oldVal = systemState.ram[i].get();
            if (newVal != oldVal) {
                systemState.ram[i].set(newVal);
                updateAssembler(i);
            }
        }, validateNumber, function () {
            var nextCell = (i + 1) % 256;
            $('#tdAssembler_' + nextCell).trigger('click');
        });
        bindContextMenu('#tdRAM_' + i, "#menuVariablen", function () {
            $('#txtRAMId').val(i);
            $('#spnRAM').html(decimalToHex(i));
            if (systemState.variableMap[i] !== undefined) {
                $('#txtVarName').val(systemState.variableMap[i]);
            }
            else {
                $('#txtVarName').val("");
            }
        });
        $('#tdRAM_' + i).on("keyup", function (event) {
            var nextCell = undefined;
            switch (event.key) {
                case "ArrowRight":
                    nextCell = i + 1;
                    break;
                case "ArrowLeft":
                    nextCell = i + 255;
                    break;
                case "ArrowUp":
                    nextCell = i + 240;
                    break;
                case "ArrowDown":
                    nextCell = i + 16;
                    break;
            }
            if (nextCell === undefined)
                return;
            var txt = writeBack($(this).children("input"), $(this));
            systemState.ram[i].set(parseInt(txt, 16));
            updateAssembler();
            nextCell = nextCell % 256;
            event.preventDefault();
            $('#tdRAM_' + nextCell).trigger('click');
        });
    };
    for (var i = 0; i < 256; i++) {
        _loop_3(i);
    }
    var hideOnOther = function (parent, menu) {
        $(document).on("contextmenu", ':not(' + parent + ')', function () {
            if ($(menu).css("display") == "block")
                toggleMenu(menu, "none");
        });
        $(window).on("click", function (e) {
            if ($(e.target).closest(menu).length > 0)
                return;
            if ($(menu).css("display") == "block")
                toggleMenu(menu, "none");
        });
    };
    hideOnOther("#tblAssembler td", "#menuRAMRow");
    hideOnOther("[id^=tdRAM_]", "#menuVariablen");
    hideOnOther("[id^=trMPS_]", "#menuMPSRow");
    systemState.ax.addObserver(function (o, n) {
        $('#txtSF').val(n > 127 ? "1" : "0");
    });
    systemState.ar.addObserver(function (o, n) {
        $('#tblRAM td').removeClass("selected_td");
        $('#tdRAM_' + n).addClass("selected_td");
    });
    systemState.currentMPS.addObserver(function (o, n) {
        $('#tblMPS tr').removeClass("selected_td");
        if ($('input[name=steuerung]:checked').val() != "m") // automatisch
         {
            var tr = $('#trMPS_' + decimalToHex(n)).addClass("selected_td");
            var div = $('#divMPS');
            var trOffset = 0;
            if (tr.offset() !== undefined)
                trOffset = tr.offset().top - $('#tblMPS').offset().top;
            var divScroll = div.prop("scrollTop");
            var divHeight = div.height();
            if (trOffset - divScroll < divHeight / 4 || trOffset - divScroll > 3 * divHeight / 4) {
                div.prop("scrollTop", trOffset - divHeight / 2);
            }
        }
    });
    systemState.ip.addObserver(function (o, n) {
        $('#tblAssembler td').removeClass("selected_td");
        $('#tr_assembler_' + (2 * Math.floor(n / 2)) + ' td').addClass("selected_td");
    });
    $('#tdRAM_0, #trMPS_00').addClass("selected_td");
    $('#dlgHelp').dialog({
        autoOpen: false,
        height: 700,
        minHeight: 500,
        width: 800,
        minWidth: 500,
        modal: true
    });
    $('#dlgAbout').dialog({
        autoOpen: false,
        height: 370,
        minHeight: 370,
        width: 420,
        minWidth: 420,
        modal: true
    });
    $('#dlgLizenz').dialog({
        autoOpen: false,
        height: 400,
        minHeight: 400,
        width: 500,
        minWidth: 500,
        modal: true
    });
    $("#dlgSaveMPS").dialog({
        autoOpen: false,
        height: 220,
        maxHeight: 220,
        minHeight: 220,
        width: 350,
        minWidth: 350,
        modal: true,
        buttons: {
            "Speichern": function () {
                doSaveMPS($('#txtMPSName').val(), $('input[name=rbnMPSSaveFormat]:checked').val() == 'd');
                updateTitle();
                $(this).dialog("close");
            },
            "Abbrechen": function () {
                $(this).dialog("close");
            }
        }
    });
    $("#dlgSaveRAM").dialog({
        autoOpen: false,
        height: 280,
        maxHeight: 280,
        minHeight: 280,
        width: 350,
        minWidth: 350,
        modal: true,
        buttons: {
            "Speichern": function () {
                doSaveRAM($('#txtRAMName').val(), $('input[name=rbnRAMSaveFormat]:checked').val());
                updateTitle();
                $(this).dialog("close");
            },
            "Abbrechen": function () {
                $(this).dialog("close");
            }
        }
    });
    $('#txtVarName').on("keyup", function (obj) {
        var txt = $(obj.target).val().trim();
        var idx = $('#txtRAMId').val();
        if (txt == "") {
            systemState.variableMap[idx] = undefined;
        }
        else if (["OP", "IP", "AX", "BX", "DR", "AR"].indexOf(txt.toUpperCase()) >= 0) {
            showToast("Fehler: Variablenname '" + txt + "' ist ungültig - mögliche Uneindeutigkeit mit Registername.");
        }
        else {
            systemState.variableMap[idx] = txt;
        }
        displayVariablen();
    });
    window.onbeforeunload = function () {
        if (systemState.isRAMChanged() || systemState.getMPS().isChanged())
            return true;
    };
    $(document).on("keyup", function (evt) {
        if (evt.code == "Space" && evt.target instanceof HTMLBodyElement) {
            alustep($('#btnAlustep').get(0));
        }
    });
    doResize();
    doResize(); // muss irgendwie sein, damit alles korrekt gezeichnet wird
    if (window.location.search != "") {
        loadURLParams();
    }
    else if (theStorage.getItem("ram")) {
        var mps = theStorage.getItem("mps");
        var ram = theStorage.getItem("ram");
        var reg = theStorage.getItem("registers");
        systemState.getMPS().loadMPD(mps);
        displayMPSContent();
        systemState.loadRAMRAS(ram);
        updateAssembler();
        resetRegisters();
        var registers = JSON.parse(reg);
        systemState.op.set(registers[0]);
        systemState.ip.set(registers[1]);
        systemState.bx.set(registers[2]);
        systemState.ax.set(registers[3]);
        systemState.dr.set(registers[4]);
        systemState.ar.set(registers[5]);
        $('#txtOP').text(decimalToHex(systemState.op.get()));
        updateTitle();
    }
    displayVariablen();
}
var theStorage = sessionStorage;
function saveToSystemStorage() {
    theStorage.setItem("ram", systemState.getRAMAsString("", "a"));
    theStorage.setItem("mps", systemState.getMPS().saveMPD("temp"));
    var registers = [systemState.op.get(), systemState.ip.get(), systemState.bx.get(), systemState.ax.get(), systemState.dr.get(), systemState.ar.get()];
    theStorage.setItem("registers", JSON.stringify(registers));
}
function showHelp() {
    $("#dlgHelp").dialog("open");
}
function showAbout() {
    $("#dlgAbout").dialog("open");
}
function lizenz() {
    $("#dlgLizenz").dialog("open");
}
function loadURLParams() {
    var urlParams = new URLSearchParams(window.location.search);
    var speed = parseInt(urlParams.get("v"));
    if (speed >= 0 && speed <= 16) {
        $("#slider").slider('value', speed);
        onSliderChanged(speed);
    }
    var mpsContent;
    if ((mpsContent = urlParams.get("mpd")) != null) {
        systemState.getMPS().loadMPD(mpsContent);
    }
    else if ((mpsContent = urlParams.get("mps")) != null) {
        var data = Uint8Array.from(atob(mpsContent), function (c) { return c.charCodeAt(0); });
        systemState.getMPS().loadMPS(data);
    }
    if (mpsContent != null) {
        displayMPSContent();
    }
    var ramContent;
    if ((ramContent = urlParams.get("ras")) != null) {
        systemState.loadRAMRAS(ramContent);
    }
    else if ((ramContent = urlParams.get("rad")) != null) {
        systemState.loadRAMRAD(ramContent);
    }
    else if ((ramContent = urlParams.get("erm")) != null) {
        var data = Uint8Array.from(atob(ramContent), function (c) { return c.charCodeAt(0); });
        systemState.loadRAMBinary(data);
    }
    if (ramContent != null) {
        displayVariablen();
        onRAMDisplayChanged();
    }
    updateAssembler();
    var autorun = urlParams.get("s") != null;
    if (autorun) {
        untilHalt("#divBtnBisHalt img");
    }
}
function displayMPSContent() {
    systemState.getMPS().lines.forEach(function (line, index) {
        var hexLine = decimalToHex(index);
        $('#mpsComment_' + hexLine).html(line.comment);
        $('#mpsFA_' + hexLine).html(decimalToHex(line.fa));
        for (var i = 0; i < 16; i++) {
            var hexCol = decimalToHex(i, 1);
            $('#mpsGate_' + hexLine + "_" + hexCol).html(line.openGates[i] ? hexCol : "");
        }
    });
}
function onSliderChanged(newspeed) {
    var zeiten = ["zu schnell", "sehr schnell", "schneller", "schnell", "0,01 s", "0,02 s", "0,03 s", "0,05 s", "0,1 s", "0,2 s", "0,3 s", "0,5 s", "1 s", "2 s", "3 s", "5 s", "10 s"];
    $('#spnSliderDescription').html("Zeit: " + zeiten[newspeed]);
}
function addVariable(varname, ramindex) {
    if (varname === undefined)
        return;
    $('#tblVariablen tr:first-child').append("<td>" + decimalToHex(ramindex) + "</td>");
    $('#tblVariablen tr:nth-child(2)').append("<td>" + varname + "</td>");
    var td = $("<td>" + decimalToHex(systemState.ram[ramindex].get()) + "</td>");
    td.appendTo($('#tblVariablen tr:nth-child(3)'));
    systemState.ram[ramindex].addObserver(function (o, n) {
        td.html(decimalToHex(n));
    });
    makeTDEditable(td, function (text) {
        systemState.ram[ramindex].set(parseInt(text, 16));
        updateAssembler();
    }, validateNumber);
    $('#tdRAM_' + ramindex).addClass("ramVariable").attr("title", varname);
}
function insertMPSRow() {
    var idx = parseInt($('#txtMPSRow').val());
    systemState.getMPS().insertRow(idx);
    displayMPSContent();
    updateAssembler();
    toggleMenu('#menuMPSRow', "none");
}
function removeMPSRow() {
    var idx = parseInt($('#txtMPSRow').val());
    systemState.getMPS().removeRow(idx);
    displayMPSContent();
    updateAssembler();
    toggleMenu('#menuMPSRow', "none");
}
function insertRAMRow() {
    var idx = parseInt($('#txtAssemblerRow').val());
    systemState.insertRAMRow(idx);
    updateAssembler(function (x) { return x > idx; });
    $('#tdBefehl_' + idx).html("").removeClass("assembler_comment");
    displayVariablen();
    toggleMenu('#menuRAMRow', "none");
    console.log(systemState.comments);
}
function removeRAMRow() {
    var idx = parseInt($('#txtAssemblerRow').val());
    systemState.removeRAMRow(idx);
    updateAssembler(function (x) { return x >= idx; });
    displayVariablen();
    toggleMenu('#menuRAMRow', "none");
}
function validateNumber(text) {
    var n = parseInt(text, 16);
    return n >= 0 && n <= 255;
}
function displayVariablen() {
    $('#tblVariablen td').remove();
    $('#tblRAM td').removeClass("ramVariable").removeAttr("title");
    systemState.variableMap.forEach(addVariable);
}
function betterReplace(where, search, replace, from) {
    if (where.length > from && from >= 0) {
        return where.slice(0, from) + where.slice(from).replace(search, replace);
    }
    return where;
}
function updateAssembler(forceOverwriteAssembler) {
    for (var i = 0; i < 256; i += 2) {
        var td = $('#tdBefehl_' + i);
        td.removeClass("assembler_comment");
        if (systemState.ram[i].get() != 0) {
            var comment = systemState.getMPS().lines[systemState.ram[i].get()].comment;
            var parameter = decimalToHex(systemState.ram[i + 1].get());
            var idxSpace = comment.indexOf(" ");
            comment = betterReplace(comment, "nn", parameter, idxSpace);
            comment = betterReplace(comment, "n", parameter, idxSpace);
            td.html(comment);
            systemState.comments[i] = comment;
        }
        else if (typeof forceOverwriteAssembler === 'number' && forceOverwriteAssembler == i) {
            td.html("");
            systemState.comments[i] = "";
        }
        else if (typeof forceOverwriteAssembler === "function" && forceOverwriteAssembler(i)) {
            td.html(systemState.comments[i]);
            if (systemState.comments[i] != "")
                td.addClass("assembler_comment");
        }
        else if (td.html().trim() != "") {
            td.addClass("assembler_comment");
        }
    }
}
function toggleGate(id, open) {
    if (id == 15) // wird nie direkt verwendet
        return;
    if (id == 13) {
        $('#spnOperation').html(open ? "&ndash;" : "+");
    }
    var imgO = $('#imgGateO' + id);
    var imgC = $('#imgGateC' + id);
    if (open) {
        if (imgO.hasClass("btnDisabled")) {
            var error = systemState.manualGates.getErrorMessage(id);
            if (error != "")
                showToast(error);
            return;
        }
        imgO.hide();
        imgC.show();
        gateExclusions[id].forEach(function (x) {
            $('#imgGateO' + x).addClass("btnDisabled");
        });
    }
    else {
        if (imgC.hasClass("btnDisabled"))
            return;
        imgO.show();
        imgC.hide();
        gateExclusions[id].forEach(function (x) {
            $('#imgGateO' + x).removeClass("btnDisabled");
        });
    }
    systemState.setManualMode(true);
    systemState.manualGates.openGates[id] = open;
    $('input[name=steuerung][value=m]').prop('checked', "checked");
    onSteuerungChanged();
}
var gateExclusions = [
    [11, 12],
    [3, 5, 11, 12],
    [11, 12],
    [1, 5, 11, 12],
    [11, 12],
    [1, 3, 11, 12],
    [11, 12],
    [9, 11, 12],
    [11, 12],
    [7, 11, 12],
    [11, 12],
    [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 13, 14],
    [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 14],
    [11, 12],
    [11, 12], // E -> B, C
];
function doResize() {
    var div = $("#divProzessor");
    var w = div.width();
    $('#cnvProzessor').attr("width", w);
    paintCanvas();
}
function paintCanvas() {
    var cnvProzessor = document.getElementById("cnvProzessor");
    var ctx = cnvProzessor.getContext("2d");
    ctx.strokeStyle = "black";
    ctx.lineWidth = 1;
    ctx.clearRect(0, 0, cnvProzessor.width, cnvProzessor.height);
    drawLineALU_AX(ctx);
    drawLineALU_BX(ctx);
    drawLineALU_IP(ctx);
    drawLineIP_ALU(ctx);
    drawLineBX_ALU(ctx);
    drawLineAX_ALU(ctx);
    drawLineALU_OP(ctx);
    drawLineOP_MPS(ctx);
    drawLine1_ALU(ctx);
    drawLineDR_ALU2(ctx, cnvProzessor.width);
    drawLineALU_DR2(ctx, cnvProzessor.width);
    drawLineALU_AR2(ctx, cnvProzessor.width);
    drawLineAX_MPS(ctx);
    drawLineD_ALU(ctx);
    if (litLines !== undefined) {
        //console.log(litLines);
        if (litLines["ax_alu"] !== undefined) {
            drawLineAX_ALU(ctx, systemState.ax.get());
        }
        if (litLines["bx_alu"] !== undefined) {
            drawLineBX_ALU(ctx, systemState.bx.get());
        }
        if (litLines["ip_alu"] !== undefined) {
            drawLineIP_ALU(ctx, systemState.ip.get());
        }
        if (litLines["1_alu"] !== undefined) {
            drawLine1_ALU(ctx, 1);
        }
        if (litLines["dr_alu"] !== undefined) {
            drawLineDR_ALU2(ctx, cnvProzessor.width, systemState.dr.get());
        }
        if (litLines["minus"] !== undefined) {
            drawLineD_ALU(ctx, 1);
        }
        if (litLines["alu_ax"] !== undefined) {
            drawLineALU_AX(ctx, systemState.alu.get());
        }
        if (litLines["alu_bx"] !== undefined) {
            drawLineALU_BX(ctx, systemState.alu.get());
        }
        if (litLines["alu_ip"] !== undefined) {
            drawLineALU_IP(ctx, systemState.alu.get());
        }
        if (litLines["alu_op"] !== undefined) {
            drawLineALU_OP(ctx, systemState.alu.get());
        }
        if (litLines["alu_ar"] !== undefined) {
            drawLineALU_AR2(ctx, cnvProzessor.width, systemState.alu.get());
        }
        if (litLines["alu_dr"] !== undefined) {
            drawLineALU_DR2(ctx, cnvProzessor.width, systemState.alu.get());
        }
        if (litLines["op_mps"] !== undefined) {
            drawLineOP_MPS(ctx, systemState.op.get());
        }
        if (litLines["sf_mps"] !== undefined) {
            drawLineAX_MPS(ctx, systemState.ax.get() >= 128 ? 1 : 0);
        }
    }
    // ALU
    ctx.fillStyle = "#dddddd";
    ctx.fillRect(263, 380, 160, 70);
    ctx.strokeStyle = "#555";
    ctx.lineWidth = 1;
    ctx.beginPath();
    ctx.rect(262, 379, 162, 72);
    ctx.stroke();
    // Bus-Canvas
    var cnvBus = document.getElementById("cnvBus");
    ctx = cnvBus.getContext("2d");
    ctx.lineWidth = 1;
    drawLineALU_AR(ctx);
    drawLineAR_RAM(ctx);
    drawLineDR_ALU(ctx);
    drawLineALU_DR(ctx);
    drawLineDR_B_RAM(ctx);
    drawLineRAM_C_DR(ctx);
    if (litLines !== undefined) {
        if (litLines["dr_ram"] !== undefined) {
            drawLineDR_B_RAM(ctx, systemState.dr.get());
        }
        if (litLines["ar_ram"] !== undefined) {
            drawLineAR_RAM(ctx, systemState.ar.get());
        }
        if (litLines["ram_dr"] !== undefined) {
            drawLineRAM_C_DR(ctx, systemState.ram[systemState.ar.get()].get());
        }
        if (litLines["alu_dr"] !== undefined) {
            drawLineALU_DR(ctx, systemState.alu.get());
        }
        if (litLines["dr_alu"] !== undefined) {
            drawLineDR_ALU(ctx, systemState.dr.get());
        }
    }
}
function drawLineALU_AX(ctx, value) {
    drawLineAluToAny(ctx, 366.5, value);
    // ALU -> AX
}
function drawLineALU_BX(ctx, value) {
    drawLineAluToAny(ctx, 312.5, value);
    // ALU -> BX
}
function drawLineALU_IP(ctx, value) {
    drawLineAluToAny(ctx, 258.5, value);
    // ALU -> IP
}
function drawDataLine(ctx, pathCallback, value) {
    for (var i = 0; i < 8; i++) {
        if (value === undefined)
            ctx.strokeStyle = "black";
        else if ((value & (1 << i)) != 0)
            ctx.strokeStyle = "yellow";
        else
            ctx.strokeStyle = "red";
        ctx.beginPath();
        pathCallback(i);
        ctx.stroke();
    }
}
function drawLineAnyToALU(ctx, y, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(110.5 + 2 * i, y - 2 * i);
        ctx.lineTo(270.5 + 2 * i, y - 2 * i);
        ctx.lineTo(270.5 + 2 * i, 380);
    }, value);
}
function drawLineIP_ALU(ctx, value) {
    drawLineAnyToALU(ctx, 258.5, value);
}
function drawLineBX_ALU(ctx, value) {
    drawLineAnyToALU(ctx, 312.5, value);
    // BX -> ALU
}
function drawLineAX_ALU(ctx, value) {
    drawLineAnyToALU(ctx, 366.5, value);
    // AX -> ALU
}
function drawLineALU_OP(ctx, value) {
    // ALU -> OP
    drawLineAluToAny(ctx, 204.5, value);
}
function drawLineAluToAny(ctx, y, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(350.5 - 14 + 2 * i, 450.5);
        ctx.lineTo(350.5 - 14 + 2 * i, 490.5 - 14 + 2 * i);
        ctx.lineTo(30.5 + 14 - 2 * i, 490.5 - 14 + 2 * i);
        ctx.lineTo(30.5 + 14 - 2 * i, y - 2 * i);
        ctx.lineTo(110.5 + 14 - 2 * i, y - 2 * i);
    }, value);
}
function drawLineOP_MPS(ctx, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(110.5, 190.5 + 14 - 2 * i);
        ctx.lineTo(270.5 + 14 - 2 * i, 190.5 + 14 - 2 * i);
        ctx.lineTo(270.5 + 14 - 2 * i, 150);
    }, value);
    // OP -> MPS
}
function drawLine1_ALU(ctx, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(330.5, 316.5 + 2 * i);
        ctx.lineTo(420.5 - 2 * i, 316.5 + 2 * i);
        ctx.lineTo(420.5 - 2 * i, 380);
    }, value);
    // 1 -> ALU
}
function drawLineDR_ALU2(ctx, width, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(width, 316.5 + 14 - 2 * i);
        ctx.lineTo(420.5 - 2 * i, 316.5 + 14 - 2 * i);
        ctx.lineTo(420.5 - 2 * i, 380);
    }, value);
    // DR -> ALU
}
function drawLineALU_DR2(ctx, width, value) {
    drawLineALUToBus(ctx, width, 386.5, value);
}
function drawLineALUToBus(ctx, width, y, value) {
    // ALU -> DR
    drawDataLine(ctx, function (i) {
        ctx.moveTo(350.5 + 2 * i - 14, 450.5);
        ctx.lineTo(350.5 + 2 * i - 14, 490.5 - 2 * i);
        ctx.lineTo(460.5 - 2 * i, 490.5 - 2 * i);
        ctx.lineTo(460.5 - 2 * i, y - 2 * i);
        ctx.lineTo(width, y - 2 * i);
    }, value);
}
function drawLineALU_AR2(ctx, width, value) {
    // ALU -> AR
    drawLineALUToBus(ctx, width, 460.5, value);
}
function drawLineAX_MPS(ctx, value) {
    // AX -> SF -> MPS
    ctx.lineWidth = 3;
    if (value === undefined)
        ctx.strokeStyle = "black";
    else if (value == 1)
        ctx.strokeStyle = "yellow";
    else
        ctx.strokeStyle = "red";
    ctx.beginPath();
    ctx.moveTo(120.5, 352.5);
    ctx.lineTo(120.5, 422.5);
    ctx.lineTo(18.5, 422.5);
    ctx.lineTo(18.5, 150);
    ctx.stroke();
    ctx.lineWidth = 1;
}
function drawLineD_ALU(ctx, value) {
    // D -> ALU
    ctx.lineWidth = 3;
    if (value === undefined)
        ctx.strokeStyle = "black";
    else if (value == 1)
        ctx.strokeStyle = "yellow";
    else
        ctx.strokeStyle = "red";
    ctx.beginPath();
    ctx.moveTo(170, 422.5);
    ctx.lineTo(280, 422.5);
    ctx.stroke();
    ctx.lineWidth = 1;
}
function drawLineALU_AR(ctx, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(0, 192.5 + 14 - 2 * i);
        ctx.lineTo(96, 192.5 + 14 - 2 * i);
    }, value);
    // ALU -> AR
}
function drawLineAR_RAM(ctx, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(96, 192.5 + 14 - 2 * i);
        ctx.lineTo(192, 192.5 + 14 - 2 * i);
    }, value);
    // AR -> RAM
}
function drawLineDR_ALU(ctx, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(0, 62.5 + 14 - 2 * i);
        ctx.lineTo(70.5 - 14 + 2 * i, 62.5 + 14 - 2 * i);
        ctx.lineTo(70.5 - 14 + 2 * i, 90.5 + 14 - 2 * i);
        ctx.lineTo(95.5, 90.5 + 14 - 2 * i);
    }, value);
    // DR -> ALU
}
function drawLineALU_DR(ctx, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(0, 118.5 + 14 - 2 * i);
        ctx.lineTo(70.5 - 2 * i, 118.5 + 14 - 2 * i);
        ctx.lineTo(70.5 - 2 * i, 90.5 + 14 - 2 * i);
        ctx.lineTo(95.5, 90.5 + 14 - 2 * i);
    }, value);
    // ALU -> DR
}
function drawLineDR_B_RAM(ctx, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(95.5, 90.5 + 14 - 2 * i);
        ctx.lineTo(120.5 + 14 - 2 * i, 90.5 + 14 - 2 * i);
        ctx.lineTo(120.5 + 14 - 2 * i, 62.5 + 14 - 2 * i);
        ctx.lineTo(192, 62.5 + 14 - 2 * i);
    }, value);
    // DR -> B -> RAM
}
function drawLineRAM_C_DR(ctx, value) {
    drawDataLine(ctx, function (i) {
        ctx.moveTo(95.5, 90.5 + 14 - 2 * i);
        ctx.lineTo(120.5 + 2 * i, 90.5 + 14 - 2 * i);
        ctx.lineTo(120.5 + 2 * i, 118.5 + 14 - 2 * i);
        ctx.lineTo(192, 118.5 + 14 - 2 * i);
    }, value);
    // RAM -> C -> DR
}
function resetRegisters(btn) {
    if (btn !== undefined && $(btn).hasClass("btnDisabled"))
        return;
    systemState.reset();
    resetGates();
}
function resetGates() {
    $("img[id^=imgGateO]:not(#imgGateO15)").show().removeClass("btnDisabled");
    $("img[id^=imgGateC]").hide();
}
var litLines = undefined;
function alustep(btn) {
    if ($(btn).hasClass("btnDisabled"))
        return;
    $("#divSimControl img").addClass("btnDisabled");
    busPhase = false;
    var wartezeit = zeiten[$("#slider").slider("option", "value")];
    bustakt1();
    setTimeout(function () {
        wartezeit = zeiten[$("#slider").slider("option", "value")];
        systemState.busTakt(false);
        litLines = systemState.getLitLines(false);
        systemState.updateMPS();
        paintCanvas();
        setTimeout(function () {
            $("#divSimControl img").removeClass("btnDisabled");
            systemState.manualGates.reset();
            resetGates();
            litLines = undefined;
            paintCanvas();
            systemState.updateMPSLine();
        }, wartezeit);
    }, wartezeit);
}
var busPhase = false;
var zeiten = [
    1,
    2,
    3,
    5,
    10,
    20,
    30,
    50,
    100,
    200,
    300,
    500,
    1000,
    2000,
    3000,
    5000,
    10000 // "10 s"
];
function busstep(btn) {
    if ($(btn).hasClass("btnDisabled"))
        return;
    $("#divSimControl img").addClass("btnDisabled");
    var wartezeit = zeiten[$("#slider").slider("option", "value")];
    busPhase = !busPhase;
    systemState.busTakt(busPhase);
    litLines = systemState.getLitLines(busPhase);
    paintCanvas();
    setTimeout(function () {
        litLines = undefined;
        paintCanvas();
        $("#divSimControl img").removeClass("btnDisabled");
        if (!busPhase && systemState.isManualMode()) {
            systemState.alu.set(0);
            systemState.manualGates.reset();
            resetGates();
        }
    }, wartezeit);
}
function doPause(btn) {
    if ($(btn).hasClass("btnDisabled"))
        return;
    killLoop = true;
}
var killLoop = false;
function singleCommand(btn) {
    if ($(btn).hasClass("btnDisabled"))
        return;
    $('#divSimControl div:not(#divBtnPause) img').addClass("btnDisabled");
    $('#divBtnPause img').removeClass("btnDisabled");
    busPhase = false;
    killLoop = false;
    autoStep(function () { return systemState.currentMPS.get() == 0 || killLoop; });
}
function bustakt1() {
    systemState.busTakt(true);
    litLines = systemState.getLitLines(true);
    systemState.getOpenGates().forEach(function (v) {
        $('#imgGateO' + v).hide();
        $('#imgGateC' + v).show();
    });
    paintCanvas();
}
function autoStep(stopCallback) {
    var wartezeit = zeiten[$("#slider").slider("option", "value")];
    bustakt1();
    setTimeout(function () {
        wartezeit = zeiten[$("#slider").slider("option", "value")];
        systemState.busTakt(false);
        litLines = systemState.getLitLines(false);
        systemState.updateMPS();
        paintCanvas();
        setTimeout(function () {
            systemState.alu.set(0);
            systemState.manualGates.reset();
            resetGates();
            litLines = undefined;
            paintCanvas();
            systemState.updateMPSLine();
            if (stopCallback()) {
                $('#divSimControl img').removeClass("btnDisabled");
                $('#divBtnPause img').addClass("btnDisabled");
            }
            else {
                autoStep(stopCallback);
            }
        }, wartezeit);
    }, wartezeit);
}
function untilHalt(btn) {
    if ($(btn).hasClass("btnDisabled"))
        return;
    $('#divSimControl div:not(#divBtnPause) img').addClass("btnDisabled");
    $('#divBtnPause img').removeClass("btnDisabled");
    busPhase = false;
    killLoop = false;
    autoStep(function () {
        return killLoop || systemState.isHaltCommand();
    });
}
function onSteuerungChanged(scrollToCurrent) {
    if ($('input[name=steuerung]:checked').val() == "m") // manuell
     {
        $('#divBtnBusstep').show();
        $('#divBtnPause, #divBtnSingle, #divBtnBisHalt').hide();
        $('#btnAlustep').attr("alt", "Alu-Takt").attr("title", "Alu-Takt");
        $('#imgGateO15').show().addClass("btnDisabled");
        $('#imgGateC15').hide();
        systemState.setManualMode(true);
    }
    else // MPS
     {
        $('#divBtnBusstep').hide();
        $('#divBtnPause, #divBtnSingle, #divBtnBisHalt').show();
        $('#btnAlustep').attr("alt", "1 Alu-Takt").attr("title", "1 Alu-Takt");
        $("img[id^=imgGateO]").show().removeClass("btnDisabled");
        $("img[id^=imgGateC]").hide();
        systemState.setManualMode(false);
    }
    if (scrollToCurrent !== undefined && scrollToCurrent)
        systemState.currentMPS.set(systemState.currentMPS.get()); // Trigger update
}
function onRAMDisplayChanged() {
    if ($('input[name=ramanzeige]:checked').val() == "a") // Assembler
     {
        $('#divRAM_assembler').show();
        $('#divRAM_inner').hide();
        $('input[name=rbnRAMSaveFormat][value=a]').prop('checked', true);
    }
    else // Daten
     {
        $('#divRAM_assembler').hide();
        $('#divRAM_inner').show();
        $('input[name=rbnRAMSaveFormat][value=d]').prop('checked', true);
    }
}
function parseAssembler(command) {
    command = command.trim().toLowerCase();
    if (command.substring(0, 1) == ";")
        return undefined;
    for (var i = 0; i < 256; i++) {
        var m = systemState.getMPS().lines[i].matches(command, systemState.variableMap);
        if (m !== undefined)
            return [i, m];
    }
    return undefined; //[0,0];
}
function resetRAM() {
    if (systemState.isRAMChanged()) {
        prettyConfirm("Sind Sie sicher, dass Sie das RAM löschen wollen?", { breite: 400, hoehe: 200 }, function () { systemState.resetRAM(); updateAssembler(); displayVariablen(); });
    }
    else {
        systemState.resetRAM();
    }
}
function resetMPS() {
    var callback = function () {
        systemState.reset();
        systemState.getMPS().reset();
        $('#tblMPS td:nth-child(n+2)').html("");
        for (var i = 0; i < 256; i++) {
            $('#mpsFA_' + (decimalToHex(i))).html(decimalToHex((i + 1) % 256));
        }
    };
    if (systemState.getMPS().isChanged()) {
        prettyConfirm("Sind Sie sicher, dass Sie den MPS löschen wollen?", { breite: 400, hoehe: 200 }, callback);
    }
    else {
        callback();
    }
}
function saveRAM() {
    $("#dlgSaveRAM").dialog("open");
}
function saveMPS() {
    $("#dlgSaveMPS").dialog("open");
}
function doSaveRAM(name, format) {
    name = name.replace(/[/\\?%*:|"<>]/g, '_');
    if (format == 'a') {
        if (!endsWith(name, ".ras"))
            name += ".ras";
        $('input[name=ramanzeige][value=a]').prop('checked', true);
        onRAMDisplayChanged();
    }
    else if (format == 'd') {
        if (!endsWith(name, ".rad"))
            name += ".rad";
        $('input[name=ramanzeige][value=d]').prop('checked', true);
        onRAMDisplayChanged();
    }
    else if (format == 's') {
        if (!endsWith(name, ".ram"))
            name += ".ram";
    }
    else {
        if (!endsWith(name, ".erm"))
            name += ".erm";
    }
    var a = document.createElement("a");
    if (format == 'a' || format == 'd') {
        var textRepresentation = systemState.getRAMAsString(name, format);
        a.href = URL.createObjectURL(new Blob([textRepresentation], { type: "text/plain" }));
    }
    else {
        var binaryRepresentation = systemState.getRAMBinary(format == 's' ? 32 : 256);
        a.href = URL.createObjectURL(new Blob([binaryRepresentation], { type: "octet/stream" }));
    }
    a.setAttribute("download", name);
    document.body.appendChild(a);
    a.click();
    document.body.removeChild(a);
}
function doSaveMPS(name, druckformat) {
    name = name.replace(/[/\\?%*:|"<>]/g, '_');
    if (druckformat) {
        if (!endsWith(name, ".mpd"))
            name += ".mpd";
    }
    else {
        if (!endsWith(name, ".mps"))
            name += ".mps";
    }
    var a = document.createElement("a");
    if (druckformat) {
        var textRepresentation = systemState.getMPS().saveMPD(name);
        a.href = URL.createObjectURL(new Blob([textRepresentation], {
            type: "text/plain"
        }));
    }
    else {
        var binaryRepresentation = systemState.getMPS().saveMPS();
        a.href = URL.createObjectURL(new Blob([binaryRepresentation], { type: "octet/stream" }));
    }
    a.setAttribute("download", name);
    document.body.appendChild(a);
    a.click();
    document.body.removeChild(a);
}
function updateTitle() {
    $(document).prop('title', "MikrSimWeb - " + $('#txtMPSName').val() + " - " + $('#txtRAMName').val());
}
function onDisplayVariablenChanged() {
    if ($('#chkVariablenansicht').prop('checked')) {
        $('#divVariablenInspektor').show();
        $('#divRAM_assembler').css("bottom", "140px");
    }
    else {
        $('#divVariablenInspektor').hide();
        $('#divRAM_assembler').css("bottom", "10px");
    }
}
var mpsPrintWindow = null;
var ramPrintWindow = null;
function printMPS() {
    var name = $('#txtMPSName').val();
    if (mpsPrintWindow === null || mpsPrintWindow.closed) {
        mpsPrintWindow = window.open("printmps.html", "printmps");
        mpsPrintWindow.onload = function () {
            mpsPrintWindow.window.displayMPS(systemState.getMPS(), name);
        };
    }
    else {
        mpsPrintWindow.postMessage([systemState.getMPS(), name]);
        mpsPrintWindow = window.open("printmps.html", "printmps");
    }
}
function printRAM() {
    var name = $('#txtRAMName').val();
    var data;
    var assemblerView = $('input[name=ramanzeige]:checked').val() == "a";
    if (assemblerView) {
        var assembler_1 = [];
        systemState.ram.forEach(function (val, idx) {
            if (idx % 2 == 0) {
                assembler_1[idx] = { op: val.get(), nn: systemState.ram[idx + 1].get(), cmd: systemState.getMPS().lines[val.get()].comment };
            }
        });
        data = JSON.stringify(assembler_1);
    }
    else {
        data = JSON.stringify(systemState.ram.map(function (x) { return x.get(); }));
    }
    if (ramPrintWindow === null || ramPrintWindow.closed) {
        ramPrintWindow = window.open("printram.html", "printram");
        ramPrintWindow.onload = function () {
            ramPrintWindow.window.displayRAM(data, name, assemblerView);
        };
    }
    else {
        ramPrintWindow.postMessage([data, name, assemblerView]);
        ramPrintWindow = window.open("printram.html", "printram");
    }
}
function toURL() {
    var baseURL = window.location.origin + window.location.pathname;
    var mps = systemState.getMPS().saveMPS();
    var b64encoded = btoa(String.fromCharCode.apply(null, mps));
    baseURL += "?mps=" + encodeURIComponent(b64encoded);
    var ram = systemState.getRAMBinary(256);
    b64encoded = btoa(String.fromCharCode.apply(null, ram));
    baseURL += "&erm=" + encodeURIComponent(b64encoded);
    navigator.clipboard.writeText(baseURL);
}
//# sourceMappingURL=main.js.map