function onMPSMessageReceived(event) {
    displayMPS(event.data[0], event.data[1]);
}
function onRAMMessageReceived(event) {
    displayRAM(event.data[0], event.data[1], event.data[2]);
}
function displayMPS(mps, name) {
    if (name === undefined) {
        name = "(unbenannt)";
        if (sessionStorage.getItem("mpsname") !== null) {
            name = sessionStorage.getItem("mpsname");
        }
    }
    else {
        sessionStorage.setItem("mpsname", name);
    }
    $(document).prop('title', "Mikroprogrammspeicher - ".concat(name, " (Druckansicht)"));
    $("h2").html("Mikroprogrammspeicher - ".concat(name));
    $("thead, tbody").empty();
    $('thead').append("<tr><th>AD</th><th>Befehl</th></tr>");
    for (var i = 0; i < 16; i++) {
        $('thead tr').append($("<th>", { text: decimalToHex(i, 1) }));
    }
    $('thead tr').append("<th>FA</th>");
    if (mps === undefined) {
        var strMps = sessionStorage.getItem("mps");
        if (strMps === null)
            return;
        mps = JSON.parse(strMps);
    }
    else {
        sessionStorage.setItem("mps", JSON.stringify(mps));
    }
    var lastRow = 255;
    while (lastRow >= 0) {
        var r = mps.lines[lastRow];
        if (r.comment != "" || r.fa != (lastRow + 1) % 256)
            break;
        if (r.openGates.filter(function (b) { return b; }).length > 0)
            break;
        lastRow--;
    }
    var mpsBody = $('tbody');
    for (var i = 0; i <= lastRow; i++) {
        var line = $("<tr>").appendTo(mpsBody);
        line.append($("<td>", { text: decimalToHex(i) }))
            .append($("<td>", { text: mps.lines[i].comment }));
        for (var g = 0; g < 16; g++) {
            line.append($("<td>", { text: mps.lines[i].openGates[g] ? decimalToHex(g, 1) : "" }));
        }
        line.append($("<td>", { text: decimalToHex(mps.lines[i].fa) }));
    }
}
function displayRAM(ram, name, assemblerView) {
    if (name === undefined) {
        name = "(unbenannt)";
        if (sessionStorage.getItem("ramname") !== null) {
            name = sessionStorage.getItem("ramname");
        }
    }
    else {
        sessionStorage.setItem("ramname", name);
    }
    if (assemblerView === undefined) {
        assemblerView = false;
        if (sessionStorage.getItem("assemblerview") !== null)
            assemblerView = sessionStorage.getItem("assemblerview") == "a";
    }
    else {
        sessionStorage.setItem("assemblerview", assemblerView ? "a" : "r");
    }
    $(document).prop('title', "RAM - ".concat(name, " (Druckansicht)"));
    $("h2").html("RAM - ".concat(name, ", ").concat(assemblerView ? "Assembler-Ansicht" : "RAM-Ansicht"));
    $("thead, tbody").empty();
    if (ram === undefined) {
        ram = null;
        if (sessionStorage.getItem("ram") !== null)
            ram = sessionStorage.getItem("ram");
    }
    else {
        sessionStorage.setItem("ram", ram);
    }
    if (ram === null)
        return;
    var oRAM = JSON.parse(ram);
    console.log(oRAM);
    $("table").removeClass("assembler").removeClass("ram");
    if (assemblerView) {
        $("table").addClass("assembler");
        $('thead').append("<tr><th>RAS</th><th>OP</th><th>nn</th><th>Befehl</th></tr>");
        var lastRow = 256;
        while (lastRow >= 0) {
            lastRow -= 2;
            if (oRAM[lastRow].op != 0 || oRAM[lastRow].nn != 0)
                break;
        }
        var body = $('tbody');
        for (var i = 0; i <= lastRow; i += 2) {
            var line = $("<tr>").appendTo(body);
            line.append($("<td>", { text: decimalToHex(i) }))
                .append($("<td>", { text: decimalToHex(oRAM[i].op) }))
                .append($("<td>", { text: decimalToHex(oRAM[i].nn) }))
                .append($("<td>", { text: oRAM[i].cmd }));
        }
    }
    else {
        $("table").addClass("ram");
        $('thead').append("<tr><th>RAD</th></tr>");
        for (var i = 0; i < 16; i++) {
            $('thead tr').append($("<th>", { text: decimalToHex(i) }));
        }
        for (var r = 0; r < 16; r++) {
            $("tbody").append("<tr><th>" + decimalToHex(16 * r) + "</th></tr>");
            for (var i = 0; i < 16; i++) {
                $("tbody tr:last-child").append($("<td>", { text: decimalToHex(oRAM[16 * r + i]) }));
            }
        }
    }
}
//# sourceMappingURL=print.js.map